DEFINE BUFFER b-sp-menuitem       FOR sp-menuitem.
DEFINE BUFFER b-sp-model-3-main   FOR sp-model-3-main.
DEFINE BUFFER b-sp-model-3-object FOR sp-model-3-object.
DEFINE BUFFER b-sp-model-3-link   FOR sp-model-3-link.

/*-- slechts eenmaal uitvoeren --*/
IF CAN-FIND(FIRST sp-control WHERE 
                  sp-control.controlkode EQ 'ca-patch-02-sp-menu-and-model3'
               OR sp-control.controlkode EQ 'ca-after-02-sp-menu-and-model3' )
THEN RETURN.

/*-- bestaande menu items aanpassen (8 stuks) --*/
/* was eerst een programma aanroep en nu een model3 aanroep */
DO TRANSACTION ON ERROR UNDO, LEAVE.
   FIND b-sp-menuitem WHERE TRUE 
    AND b-sp-menuitem.menuitemkode = 'EDI_IFTMCS'
    AND b-sp-menuitem.applicatiekode = 'CA'
    EXCLUSIVE-LOCK NO-ERROR.
    IF NOT AVAILABLE b-sp-menuitem
    THEN CREATE b-sp-menuitem.
    ASSIGN 
   	b-sp-menuitem.menuitemkode = 'EDI_IFTMCS'
   	b-sp-menuitem.soort = 'model-3'
   	b-sp-menuitem.naam = 'CA-EDI_CREATE_FILE'
   	b-sp-menuitem.applicatiekode = 'CA'
   	b-sp-menuitem.multirun = no
   	b-sp-menuitem.parameters = 'type=IFTMCS' 
   	b-sp-menuitem.versie9 = yes
   	b-sp-menuitem.menulabel = 'B/L (IFTMCS)'
   	b-sp-menuitem.menupublic = no
   	.
   FIND b-sp-menuitem WHERE TRUE 
    AND b-sp-menuitem.menuitemkode = 'EDI_COPRAR'
    AND b-sp-menuitem.applicatiekode = 'CA'
    EXCLUSIVE-LOCK NO-ERROR.
    IF NOT AVAILABLE b-sp-menuitem
    THEN CREATE b-sp-menuitem.
    ASSIGN 
   	b-sp-menuitem.menuitemkode = 'EDI_COPRAR'
   	b-sp-menuitem.soort = 'model-3'
   	b-sp-menuitem.naam = 'CA-EDI_CREATE_FILE'
   	b-sp-menuitem.applicatiekode = 'CA'
   	b-sp-menuitem.multirun = no
   	b-sp-menuitem.parameters = 'type=COPRAR'
   	b-sp-menuitem.versie9 = yes
   	b-sp-menuitem.menulabel = 'Container discharge/loading order message (COPRAR)'
   	b-sp-menuitem.menupublic = no
   	b-sp-menuitem.available_for_customer = 'softpak,Nirint,ECH'
   	.
   FIND b-sp-menuitem WHERE TRUE 
    AND b-sp-menuitem.menuitemkode = 'EDI_COPRAR-ECT'
    AND b-sp-menuitem.applicatiekode = 'CA'
    EXCLUSIVE-LOCK NO-ERROR.
    IF NOT AVAILABLE b-sp-menuitem
    THEN CREATE b-sp-menuitem.
    ASSIGN 
   	b-sp-menuitem.menuitemkode = 'EDI_COPRAR-ECT'
   	b-sp-menuitem.soort = 'model-3'
   	b-sp-menuitem.naam = 'CA-EDI_CREATE_FILE'
   	b-sp-menuitem.applicatiekode = 'CA'
   	b-sp-menuitem.multirun = no
   	b-sp-menuitem.parameters = 'type=COPRAR-ECT'
   	b-sp-menuitem.versie9 = yes
   	b-sp-menuitem.menulabel = 'Container discharge/loading order ECT'
   	b-sp-menuitem.menupublic = no
   	b-sp-menuitem.available_for_customer = 'softpak,Eurofeeders'
   	.
   FIND b-sp-menuitem WHERE TRUE 
    AND b-sp-menuitem.menuitemkode = 'EDI_CUSCAR'
    AND b-sp-menuitem.applicatiekode = 'CA'
    EXCLUSIVE-LOCK NO-ERROR.
    IF NOT AVAILABLE b-sp-menuitem
    THEN CREATE b-sp-menuitem.
    ASSIGN 
   	b-sp-menuitem.menuitemkode = 'EDI_CUSCAR'
   	b-sp-menuitem.soort = 'model-3'
   	b-sp-menuitem.naam = 'CA-EDI_CREATE_FILE'
   	b-sp-menuitem.applicatiekode = 'CA'
   	b-sp-menuitem.multirun = no
   	b-sp-menuitem.parameters = 'type=CUSCAR'
   	b-sp-menuitem.versie9 = yes
   	b-sp-menuitem.menulabel = 'Customs Cargo Manifest (CUSCAR)'
   	b-sp-menuitem.menupublic = no
   	b-sp-menuitem.available_for_customer = 'Eurofeeders'
   	.
   FIND b-sp-menuitem WHERE TRUE 
    AND b-sp-menuitem.menuitemkode = 'EDI_GSMCAR'
    AND b-sp-menuitem.applicatiekode = 'CA'
    EXCLUSIVE-LOCK NO-ERROR.
    IF NOT AVAILABLE b-sp-menuitem
    THEN CREATE b-sp-menuitem.
    ASSIGN 
   	b-sp-menuitem.menuitemkode = 'EDI_GSMCAR'
   	b-sp-menuitem.soort = 'model-3'
   	b-sp-menuitem.naam = 'CA-EDI_CREATE_FILE'
   	b-sp-menuitem.applicatiekode = 'CA'
   	b-sp-menuitem.multirun = no
   	b-sp-menuitem.parameters = 'type=GSMCAR'
   	b-sp-menuitem.versie9 = yes
   	b-sp-menuitem.menulabel = 'Customs Cargo Manifest Canada (GSMCAR)'
   	b-sp-menuitem.menupublic = no
   	.
   FIND b-sp-menuitem WHERE TRUE 
    AND b-sp-menuitem.menuitemkode = 'EDI_IFCSUM'
    AND b-sp-menuitem.applicatiekode = 'CA'
    EXCLUSIVE-LOCK NO-ERROR.
    IF NOT AVAILABLE b-sp-menuitem
    THEN CREATE b-sp-menuitem.
    ASSIGN 
   	b-sp-menuitem.menuitemkode = 'EDI_IFCSUM'
   	b-sp-menuitem.soort = 'model-3'
   	b-sp-menuitem.naam = 'CA-EDI_CREATE_FILE'
   	b-sp-menuitem.applicatiekode = 'CA'
   	b-sp-menuitem.multirun = no
   	b-sp-menuitem.parameters = 'type=IFCSUM'
   	b-sp-menuitem.versie9 = yes
   	b-sp-menuitem.menulabel = 'Cargo Manifest Cuba (IFCSUM)'
   	b-sp-menuitem.menupublic = no
   	b-sp-menuitem.available_for_customer = 'Nirint,ECH'
   	.
   FIND b-sp-menuitem WHERE TRUE 
    AND b-sp-menuitem.menuitemkode = 'EDI_IFTDGN'
    AND b-sp-menuitem.applicatiekode = 'CA'
    EXCLUSIVE-LOCK NO-ERROR.
    IF NOT AVAILABLE b-sp-menuitem
    THEN CREATE b-sp-menuitem.
    ASSIGN 
   	b-sp-menuitem.menuitemkode = 'EDI_IFTDGN'
   	b-sp-menuitem.soort = 'model-3'
   	b-sp-menuitem.naam = 'CA-EDI_CREATE_FILE'
   	b-sp-menuitem.applicatiekode = 'CA'
   	b-sp-menuitem.multirun = no
   	b-sp-menuitem.parameters = 'type=IFTDGN'
   	b-sp-menuitem.versie9 = yes
   	b-sp-menuitem.menulabel = 'Dangerous goods message (IFTDGN)'
   	b-sp-menuitem.menupublic = no
   	.
   FIND b-sp-menuitem WHERE TRUE 
    AND b-sp-menuitem.menuitemkode = 'EDI_IFTMCS_PIL'
    AND b-sp-menuitem.applicatiekode = 'CA'
    EXCLUSIVE-LOCK NO-ERROR.
    IF NOT AVAILABLE b-sp-menuitem
    THEN CREATE b-sp-menuitem.
    ASSIGN 
   	b-sp-menuitem.menuitemkode = 'EDI_IFTMCS_PIL'
   	b-sp-menuitem.soort = 'model-3'
   	b-sp-menuitem.naam = 'CA-EDI_CREATE_FILE'
   	b-sp-menuitem.applicatiekode = 'CA'
   	b-sp-menuitem.multirun = no
   	b-sp-menuitem.parameters = 'type=IFTMCS-PIL'
   	b-sp-menuitem.versie9 = yes
   	b-sp-menuitem.menulabel = 'Electronisch manifest Port infolink (IFTMCS)'
   	b-sp-menuitem.menupublic = no
   	.
   
   /*-- model 3 EDI_CREATE_FILE toevoegen --*/
   /* deze vervangt het vergelijkbare model3 EDI_COPRAR 
      EDI_COPRAR verdwijnt vanzelf met release 9.3 en 
      kan nu weinig kwaad */
   FIND b-sp-model-3-main WHERE TRUE 
    AND b-sp-model-3-main.applicatiekode = 'CA'
    AND b-sp-model-3-main.modelkode = 'EDI_CREATE_FILE'
    EXCLUSIVE-LOCK NO-ERROR.
    IF NOT AVAILABLE b-sp-model-3-main
    THEN CREATE b-sp-model-3-main.
    ASSIGN 
   	b-sp-model-3-main.applicatiekode = 'CA'
   	b-sp-model-3-main.modelkode = 'EDI_CREATE_FILE'
   	b-sp-model-3-main.soort = 5
   	b-sp-model-3-main.menuitemkode = 'WIN-V9-DEFAULT'
   	b-sp-model-3-main.menuapplicatiekode = 'SP'
   	b-sp-model-3-main.startuppage = 1
   	b-sp-model-3-main.context_id = 0
   	b-sp-model-3-main.versie9 = no
   	b-sp-model-3-main.overrule = yes
   	b-sp-model-3-main.w_height = 15.5
   	b-sp-model-3-main.w_width = 87
   	b-sp-model-3-main.initallpages = yes
   	b-sp-model-3-main.favorite = no
   	b-sp-model-3-main.modal = no
   	b-sp-model-3-main.titel = 'Create EDI file'
   	b-sp-model-3-main.ind_can_compswitch = no
   	.
   
   FIND b-sp-model-3-object WHERE TRUE 
    AND b-sp-model-3-object.applicatiekode = 'CA'
    AND b-sp-model-3-object.modelkode = 'EDI_CREATE_FILE'
    AND b-sp-model-3-object.objectkode = 'v-viewer'
    EXCLUSIVE-LOCK NO-ERROR.
    IF NOT AVAILABLE b-sp-model-3-object
    THEN CREATE b-sp-model-3-object.
    ASSIGN 
   	b-sp-model-3-object.applicatiekode = 'CA'
   	b-sp-model-3-object.modelkode = 'EDI_CREATE_FILE'
   	b-sp-model-3-object.pagenr = 1
   	b-sp-model-3-object.objectname = 'CA/object/v-ca-shipment_edi_out.w'
   	b-sp-model-3-object.objectrow = 1.05
   	b-sp-model-3-object.objectcolumn = 1.2
   	b-sp-model-3-object.objectkode = 'v-viewer'
   	b-sp-model-3-object.height = 0
   	b-sp-model-3-object.width = 0
   	b-sp-model-3-object.overrule = yes
   	b-sp-model-3-object.parameterflag = no
   	b-sp-model-3-object.external = no
   	b-sp-model-3-object.ind_dynamic = no
   	.
   FIND b-sp-model-3-object WHERE TRUE 
    AND b-sp-model-3-object.applicatiekode = 'CA'
    AND b-sp-model-3-object.modelkode = 'EDI_CREATE_FILE'
    AND b-sp-model-3-object.objectkode = 's-data'
    EXCLUSIVE-LOCK NO-ERROR.
    IF NOT AVAILABLE b-sp-model-3-object
    THEN CREATE b-sp-model-3-object.
    ASSIGN 
   	b-sp-model-3-object.applicatiekode = 'CA'
   	b-sp-model-3-object.modelkode = 'EDI_CREATE_FILE'
   	b-sp-model-3-object.pagenr = 0
   	b-sp-model-3-object.objectname = 'ca/object/s-ca-u_shipment.w'
   	b-sp-model-3-object.objectrow = 0
   	b-sp-model-3-object.objectcolumn = 0
   	b-sp-model-3-object.objectkode = 's-data'
   	b-sp-model-3-object.height = 0
   	b-sp-model-3-object.width = 0
   	b-sp-model-3-object.overrule = no
   	b-sp-model-3-object.parameterflag = no
   	b-sp-model-3-object.external = no
   	b-sp-model-3-object.ind_dynamic = no
   	.
   FIND b-sp-model-3-link WHERE TRUE 
    AND b-sp-model-3-link.applicatiekode = 'CA'
    AND b-sp-model-3-link.modelkode = 'EDI_CREATE_FILE'
    AND b-sp-model-3-link.link_source = 's-data'
    AND b-sp-model-3-link.link_type = 'Data'
    AND b-sp-model-3-link.link_target = 'v-viewer'
    AND b-sp-model-3-link.linknaam = ''
    AND b-sp-model-3-link.linkuitleg = ''
    EXCLUSIVE-LOCK NO-ERROR.
    IF NOT AVAILABLE b-sp-model-3-link
    THEN CREATE b-sp-model-3-link.
    ASSIGN 
   	b-sp-model-3-link.applicatiekode = 'CA'
   	b-sp-model-3-link.modelkode = 'EDI_CREATE_FILE'
   	b-sp-model-3-link.link_source = 's-data'
   	b-sp-model-3-link.link_type = 'Data'
   	b-sp-model-3-link.link_target = 'v-viewer'
   	.
   FIND b-sp-model-3-link WHERE TRUE 
    AND b-sp-model-3-link.applicatiekode = 'CA'
    AND b-sp-model-3-link.modelkode = 'EDI_CREATE_FILE'
    AND b-sp-model-3-link.link_source = 'v-viewer'
    AND b-sp-model-3-link.link_type = 'Update'
    AND b-sp-model-3-link.link_target = 's-data'
    AND b-sp-model-3-link.linknaam = ''
    AND b-sp-model-3-link.linkuitleg = ''
    EXCLUSIVE-LOCK NO-ERROR.
    IF NOT AVAILABLE b-sp-model-3-link
    THEN CREATE b-sp-model-3-link.
    ASSIGN 
   	b-sp-model-3-link.applicatiekode = 'CA'
   	b-sp-model-3-link.modelkode = 'EDI_CREATE_FILE'
   	b-sp-model-3-link.link_source = 'v-viewer'
   	b-sp-model-3-link.link_type = 'Update'
   	b-sp-model-3-link.link_target = 's-data'
   	.
      
   /*-- registreren voor toekomstige runs --*/
   CREATE sp-control.
   ASSIGN sp-control.controlkode = 'ca-patch-02-sp-menu-and-model3'
          sp-control.lijst       = 'uitgevoerd op ' + STRING(TODAY,'99-99-9999') + ' ' + STRING(TIME,'HH:MM:SS')
          sp-control.uitleg      = '8 EDI menu items bijwerken en 1 model3 (EDI_CREATE_FILE) toevoegen'.
END. /*TRANSACTION*/
          
