/*-- database inconsistencies wegwerken --*/
   DEF BUFFER b-ca-u_shipment_item_tariff FOR ca-u_shipment_item_tariff.
   DEF BUFFER b-ca-i_shipment_item_tariff FOR ca-i_shipment_item_tariff.
   DEF BUFFER b-ca-u_booking_item_tariff  FOR ca-u_booking_item_tariff.
   DEF BUFFER b-ca-quotation_item_tariff  FOR ca-quotation_item_tariff.
   
   /*-- slechts eenmaal uitvoeren --*/
   IF CAN-FIND(FIRST sp-control WHERE 
                     sp-control.controlkode EQ 'ca-patch-06-update-general'
                  OR sp-control.controlkode EQ 'ca-after-06-update-general' )
   THEN RETURN.
   
   /* dit komt bovenop vernieuwde database triggers voor onderstaande tabellen*/
   DISABLE TRIGGERS FOR LOAD OF ca-u_shipment_item_tariff.
   DISABLE TRIGGERS FOR LOAD OF ca-i_shipment_item_tariff.
   DISABLE TRIGGERS FOR LOAD OF ca-u_booking_item_tariff.
   DISABLE TRIGGERS FOR LOAD OF ca-quotation_item_tariff.
   
   FOR EACH ca-u_shipment_item_tariff WHERE
            ca-u_shipment_item_tariff.general    EQ YES
        AND ca-u_shipment_item_tariff.item_seqnr NE 0
        OR  ca-u_shipment_item_tariff.general    EQ NO
        AND ca-u_shipment_item_tariff.item_seqnr EQ 0
            NO-LOCK:
      DO TRANSACTION:
         FIND b-ca-u_shipment_item_tariff WHERE
              ROWID(b-ca-u_shipment_item_tariff) EQ ROWID(ca-u_shipment_item_tariff)
              EXCLUSIVE-LOCK.
         ASSIGN b-ca-u_shipment_item_tariff.general = (ca-u_shipment_item_tariff.item_seqnr EQ 0).
      END. /*transaction*/
   END. /*each*/
   FOR EACH ca-i_shipment_item_tariff WHERE
            ca-i_shipment_item_tariff.general    EQ YES
        AND ca-i_shipment_item_tariff.item_seqnr NE 0
        OR  ca-i_shipment_item_tariff.general    EQ NO
        AND ca-i_shipment_item_tariff.item_seqnr EQ 0
            NO-LOCK:
      DO TRANSACTION:
         FIND b-ca-i_shipment_item_tariff WHERE
              ROWID(b-ca-i_shipment_item_tariff) EQ ROWID(ca-i_shipment_item_tariff)
              EXCLUSIVE-LOCK.
         ASSIGN b-ca-i_shipment_item_tariff.general = (ca-i_shipment_item_tariff.item_seqnr EQ 0).
      END. /*transaction*/
   END. /*each*/
   FOR EACH ca-u_booking_item_tariff WHERE
            ca-u_booking_item_tariff.general    EQ YES
        AND ca-u_booking_item_tariff.item_seqnr NE 0
        OR  ca-u_booking_item_tariff.general    EQ NO
        AND ca-u_booking_item_tariff.item_seqnr EQ 0
            NO-LOCK:
      DO TRANSACTION:
         FIND b-ca-u_booking_item_tariff WHERE
              ROWID(b-ca-u_booking_item_tariff) EQ ROWID(ca-u_booking_item_tariff)
              EXCLUSIVE-LOCK.
         ASSIGN b-ca-u_booking_item_tariff.general = (ca-u_booking_item_tariff.item_seqnr EQ 0).
      END. /*transaction*/   
   END. /*each*/
   FOR EACH ca-quotation_item_tariff WHERE
            ca-quotation_item_tariff.general    EQ YES
        AND ca-quotation_item_tariff.item_seqnr NE 0
        OR  ca-quotation_item_tariff.general    EQ NO
        AND ca-quotation_item_tariff.item_seqnr EQ 0
            NO-LOCK:
      DO TRANSACTION:
         FIND b-ca-quotation_item_tariff WHERE
              ROWID(b-ca-quotation_item_tariff) EQ ROWID(ca-quotation_item_tariff)
              EXCLUSIVE-LOCK.
         ASSIGN b-ca-quotation_item_tariff.general = (ca-quotation_item_tariff.item_seqnr EQ 0).
      END. /*transaction*/
   END. /*each*/
   
   DO TRANSACTION:
      /*-- registreren voor toekomstige runs --*/
      CREATE sp-control.
      ASSIGN sp-control.controlkode = 'ca-patch-06-update-general'
             sp-control.lijst       = 'uitgevoerd op ' + STRING(TODAY,'99-99-9999') + ' ' + STRING(TIME,'HH:MM:SS')
             sp-control.uitleg      = 'Corrupte data wegwerken in i&u shipment, booking & quotation'.
   END.
                
