define button   btnOk        label "&Start"      size-pixels 80 by 23.
define button   btnAnnuleren label "&Annuleren"  size-pixels 80 by 23.

DEFINE VARIABLE sp-companycode LIKE sp-company.companycode NO-UNDO.
define variable cFrom          like aa-line.linecode NO-UNDO FORMAT "X(55)" VIEW-AS COMBO-BOX INNER-LINES 35.
define variable cTo            like aa-line.linecode NO-UNDO FORMAT "X(55)" VIEW-AS COMBO-BOX INNER-LINES 35.

define variable iDone    as integer view-as text no-undo.

define var cLinecodeFrom as char no-undo. 
define var cLinecodeTo   as char no-undo. 
define var cTableList    as char no-undo. 
define var iModulo       as int  no-undo. 

define variable lDebug as logical view-as toggle-box no-undo.

define variable cTable as char format "x(30)" view-as text no-undo. 

ASSIGN cTableList =  'ca-s_item'               
                  + ',ca-s_vessel_da'          
                  + ',aa-vessel'
                  + ',aa-vessel_cur_rate'                  
       iModulo    =  100.  /* om de 100 records info tonen */

define stream logfile. 

sp-companycode = "LEMM".

&GLOBAL-DEFINE mydisplay iDone WITH FRAME x

define frame x

  cFrom              at column 19    row 1.5 colon-aligned  label "From linecode" 
  cTo                at column 19    row 2.6 colon-aligned  label "to linecode"
  
  lDebug             at column 19    row 4   colon-aligned label "Debug only"

  cTable             at column 19    row 5.4 colon-aligned  label "Busy with table"
  iDone              at column 19    row 6.5 colon-aligned  label "Num done"

  btnOk              at column 86   row 1.5
  btnAnnuleren       at column 86   row 2.8

  with size 105 by 8 side-labels three-d overlay row 2.5
       title "omzetten linecode" default-button btnOk keep-tab-order
       view-as dialog-box font 1.


/* -------------------------------------------------------------------------------- */
/* -------------------------------------------------------------------------------- */
ON CHOOSE OF btnOk DO:

  ASSIGN cFrom cTo lDebug.
  
  IF NUM-ENTRIES(cFrom,"[") = 2
  THEN DO:
    cLinecodeFrom = ENTRY(2,cFrom,"["). 
    cLinecodeFrom = REPLACE(cLinecodeFrom,"]",""). 
  END.  

  IF NUM-ENTRIES(cTo,"[") = 2 
  THEN DO:
    cLinecodeTo = ENTRY(2,cTo,"["). 
    cLinecodeTo = REPLACE(cLinecodeTo,"]",""). 
  END.
 
  IF cLinecodeFrom = "" OR cLinecodeTo = "" OR (cLinecodeFrom = cLinecodeTo)
  THEN DO: 
    MESSAGE "Bad selection" view-as alert-box.
    RETURN NO-APPLY.
  END.
  
  FIND FIRST aa-line WHERE aa-line.linecode = cLinecodeFrom NO-LOCK NO-ERROR.
  IF NOT AVAIL aa-line
  THEN DO:
    MESSAGE "Oops; could not find (1) " cLinecodeFrom VIEW-AS ALERT-BOX.
    RETURN NO-APPLY. 
  END. 

  FIND FIRST aa-line WHERE aa-line.linecode = cLinecodeTo NO-LOCK NO-ERROR.
  IF NOT AVAIL aa-line
  THEN DO:
    MESSAGE "Oops; could not find (2) " cLinecodeTo VIEW-AS ALERT-BOX.
    RETURN NO-APPLY. 
  END. 
  
  MESSAGE "Change linecode" cLinecodeFrom "to" cLinecodeTo "?" chr(10) chr(10) 
          "For tables: " cTableList  
                    
     VIEW-AS ALERT-BOX QUESTION BUTTONS YES-NO UPDATE lJaGraag AS LOGICAL.
  
  IF NOT lJaGraag THEN RETURN NO-APPLY.
  
  iDone = 0.
  cTable = "".
  
  RUN doChangeLinecodes.     
  
  
  
END. /* choose OK */ 


FOR EACH aa-line WHERE aa-line.companycode = sp-companycode NO-LOCK: 

  cFrom:ADD-LAST (aa-line.des + " [" + aa-line.linecode + "]" ).
  cTo:ADD-LAST   (aa-line.des + " [" + aa-line.linecode + "]").

END.

cFrom:ADD-FIRST ("<select>"). 
cTo:ADD-FIRST ("<select>"). 
     
cFrom = "<select>". 
cTo = "<select>".      
             
ENABLE ALL WITH FRAME X.
DISPLAY cFrom cTo iDone WITH FRAME x.

WAIT-FOR CHOOSE OF btnAnnuleren.


/* ------------------------------------------------------------------------------------------- */
/* ------------------------------------------------------------------------------------------- */
PROCEDURE doChangeLinecodes:

   DEFINE VARIABLE cLogfile AS CHAR NO-UNDO. 
   DEFINE VARIABLE cDebug  AS CHAR FORMAT "X(80)".
   
   cLogfile = SESSION:TEMP-DIRECTORY + "change-linecode.log".

   IF lDebug THEN OUTPUT STREAM logfile TO VALUE(cLogfile). 

   SESSION:SET-WAIT-STATE("GENERAL"). 

   {ca/conversion/tools/change-linecode-script.i ca-s_item                cLinecodeFrom  cLinecodeTo }
   {ca/conversion/tools/change-linecode-script.i ca-s_vessel_da           cLinecodeFrom  cLinecodeTo }
   {ca/conversion/tools/change-linecode-script.i aa-vessel                cLinecodeFrom  cLinecodeTo }
   {ca/conversion/tools/change-linecode-script.i aa-vessel_cur_rate       cLinecodeFrom  cLinecodeTo } 

   SESSION:SET-WAIT-STATE(""). 
 
   IF lDebug THEN DO:
     OUTPUT STREAM logfile CLOSE.
     MESSAGE "Done, check Logfile" cLogfile VIEW-AS ALERT-BOX.
   END.
   ELSE
     MESSAGE "Done" VIEW-AS ALERT-BOX.
    
 END.

