&ANALYZE-SUSPEND _VERSION-NUMBER AB_v9r12 GUI ADM2
&ANALYZE-RESUME
/* Connected Databases 
          sp               PROGRESS
*/
&Scoped-define WINDOW-NAME wWin
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS wWin 
/*------------------------------------------------------------------------

  File: 

  Description: from cntnrwin.w - ADM SmartWindow Template

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  History: New V9 Version - January 15, 1998
          
------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AB.              */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */
{system/include/sp-window-def.i}  /* sp-applicatie, sp-menu, sp-help, sp-help_id*/
{system/include/sp-allobjects-def.i}

ASSIGN sp-applicatie = ""
       sp-menu       = ""
       sp-help       = ""
       sp-help_id    = 0.

/* Parameters Definitions ---                                           */

/* Local Variable Definitions ---                                       */
DEF TEMP-TABLE ttTable NO-UNDO
   FIELD UID            AS INT
   FIELD cColNameHeader AS CHAR LABEL 'ColNameHeader' FORMAT 'X(35)'
   FIELD cFile          AS CHAR LABEL 'File'          FORMAT 'X950)'
   FIELD cLabel         AS CHAR LABEL 'Table'         FORMAT 'X(35)'
   FIELD cFormat        AS CHAR LABEL 'Format'        FORMAT 'X(15)'
   FIELD cDelimiter     AS CHAR LABEL 'Del.'
   FIELD iMaxScanRows   AS INT  LABEL 'Mx Scn Rws'
   FIELD cCharacterset  AS CHAR LABEL 'Chr Set'
   FIELD iNumEntries    AS INT
   FIELD lMatchSearch   AS LOG .

DEF TEMP-TABLE ttCol   NO-UNDO
   FIELD UID            AS INT 
   FIELD table-UID      AS INT
   FIELD cCol           AS CHAR LABEL 'Col'  
   FIELD cName          AS CHAR LABEL 'Name' FORMAT 'X(25)'
   FIELD cType          AS CHAR LABEL 'Type'
   FIELD iWidth         AS INT  LABEL 'Width'
   FIELD iEntry         AS INT  LABEL 'Entry'
   FIELD lMatchSearch   AS LOG .

DEF TEMP-TABLE ttValue NO-UNDO
   FIELD UID            AS INT
   FIELD colUID        AS INT
   FIELD iRow           AS INT  LABEL 'Row'   FORMAT '>>9'
   FIELD cValue         AS CHAR LABEL 'Value' FORMAT 'X(256)'
   FIELD lMatchSearch   AS LOG .

DEF VAR ghTmpMatrix AS HANDLE NO-UNDO.
DEF VAR ghQryMatrix AS HANDLE NO-UNDO.
DEF VAR ghBrwMatrix AS HANDLE NO-UNDO.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE SmartWindow
&Scoped-define DB-AWARE no

&Scoped-define ADM-CONTAINER WINDOW

&Scoped-define ADM-SUPPORTED-LINKS Data-Target,Data-Source,Page-Target

/* Name of first Frame and/or Browse and/or first Query                 */
&Scoped-define FRAME-NAME fMain
&Scoped-define BROWSE-NAME brCols

/* Internal Tables (found by Frame, Query & Browse Queries)             */
&Scoped-define INTERNAL-TABLES ttCol ttTable ttValue

/* Definitions for BROWSE brCols                                        */
&Scoped-define FIELDS-IN-QUERY-brCols ttCol.cCol ttCol.cName ttCol.cType ttCol.iWidth   
&Scoped-define ENABLED-FIELDS-IN-QUERY-brCols   
&Scoped-define SELF-NAME brCols
&Scoped-define OPEN-QUERY-brCols OPEN QUERY {&SELF-NAME}    FOR EACH ttCol WHERE             ttCol.table-UID EQ ttTable.UID             NO-LOCK.
&Scoped-define TABLES-IN-QUERY-brCols ttCol
&Scoped-define FIRST-TABLE-IN-QUERY-brCols ttCol


/* Definitions for BROWSE brTables                                      */
&Scoped-define FIELDS-IN-QUERY-brTables ttTable.cLabel   
&Scoped-define ENABLED-FIELDS-IN-QUERY-brTables   
&Scoped-define SELF-NAME brTables
&Scoped-define OPEN-QUERY-brTables OPEN QUERY {&SELF-NAME}    FOR EACH ttTable NO-LOCK.
&Scoped-define TABLES-IN-QUERY-brTables ttTable
&Scoped-define FIRST-TABLE-IN-QUERY-brTables ttTable


/* Definitions for BROWSE brValues                                      */
&Scoped-define FIELDS-IN-QUERY-brValues ttValue.iRow ttValue.cValue   
&Scoped-define ENABLED-FIELDS-IN-QUERY-brValues   
&Scoped-define SELF-NAME brValues
&Scoped-define OPEN-QUERY-brValues OPEN QUERY {&SELF-NAME}    FOR EACH ttValue WHERE             ttValue.colUID EQ ttCol.UID         AND ttValue.iRow    GE 2             NO-LOCK.
&Scoped-define TABLES-IN-QUERY-brValues ttValue
&Scoped-define FIRST-TABLE-IN-QUERY-brValues ttValue


/* Definitions for FRAME fMain                                          */
&Scoped-define OPEN-BROWSERS-IN-QUERY-fMain ~
    ~{&OPEN-QUERY-brCols}~
    ~{&OPEN-QUERY-brTables}~
    ~{&OPEN-QUERY-brValues}

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS fiColNameHeader fiFile btnViewFile brTables ~
fiFormat fiMaxScanRows fiDelimiter fiCharacterSet fiSearchValue brCols ~
brValues edValue rctMatrix 
&Scoped-Define DISPLAYED-OBJECTS fiColNameHeader fiFile fiFormat ~
fiMaxScanRows fiDelimiter fiCharacterSet fiReport fiSearchValue edValue 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */

/* Define the widget handle for the window                              */
DEFINE VAR wWin AS WIDGET-HANDLE NO-UNDO.

/* Menu Definitions                                                     */
DEFINE MENU MENU-BAR-wWin MENUBAR
       MENU-ITEM mRefresh       LABEL "Refresh"       .


/* Definitions of the field level widgets                               */
DEFINE BUTTON btnEmail 
     LABEL "Email zip" 
     SIZE 15 BY 1.14.

DEFINE BUTTON btnViewFile 
     LABEL "View File" 
     SIZE 15 BY 1.14.

DEFINE BUTTON btnXR 
     LABEL "Open in XR" 
     SIZE 15 BY 1.14.

DEFINE VARIABLE edValue AS CHARACTER 
     VIEW-AS EDITOR NO-WORD-WRAP SCROLLBAR-HORIZONTAL SCROLLBAR-VERTICAL
     SIZE 54 BY 4.76 NO-UNDO.

DEFINE VARIABLE fiCharacterSet AS CHARACTER FORMAT "X(256)":U 
     LABEL "Character Set" 
     VIEW-AS FILL-IN 
     SIZE 14 BY 1 NO-UNDO.

DEFINE VARIABLE fiColNameHeader AS CHARACTER FORMAT "X(256)":U 
     LABEL "ColNameHeader" 
     VIEW-AS FILL-IN 
     SIZE 25.8 BY 1 NO-UNDO.

DEFINE VARIABLE fiDelimiter AS CHARACTER FORMAT "X(256)":U 
     LABEL "Delimiter" 
     VIEW-AS FILL-IN 
     SIZE 16 BY 1 NO-UNDO.

DEFINE VARIABLE fiFile AS CHARACTER FORMAT "X(256)":U 
     LABEL "File" 
     VIEW-AS FILL-IN 
     SIZE 46.2 BY 1 NO-UNDO.

DEFINE VARIABLE fiFormat AS CHARACTER FORMAT "X(256)":U 
     LABEL "Format" 
     VIEW-AS FILL-IN 
     SIZE 16 BY 1 NO-UNDO.

DEFINE VARIABLE fiMaxScanRows AS INTEGER FORMAT ">>9":U INITIAL 0 
     LABEL "Max Scan Rows" 
     VIEW-AS FILL-IN 
     SIZE 14 BY 1 NO-UNDO.

DEFINE VARIABLE fiReport AS CHARACTER FORMAT "X(256)":U 
     LABEL "Report" 
     VIEW-AS FILL-IN 
     SIZE 48.6 BY 1 NO-UNDO.

DEFINE VARIABLE fiSearchValue AS CHARACTER FORMAT "X(256)":U INITIAL "Enter Search Value, use * to search mid string" 
     VIEW-AS FILL-IN 
     SIZE 111.6 BY 1
     FGCOLOR 8  NO-UNDO.

DEFINE RECTANGLE rctMatrix
     EDGE-PIXELS 2 GRAPHIC-EDGE  NO-FILL 
     SIZE 153 BY 8.57.

/* Query definitions                                                    */
&ANALYZE-SUSPEND
DEFINE QUERY brCols FOR 
      ttCol SCROLLING.

DEFINE QUERY brTables FOR 
      ttTable SCROLLING.

DEFINE QUERY brValues FOR 
      ttValue SCROLLING.
&ANALYZE-RESUME

/* Browse definitions                                                   */
DEFINE BROWSE brCols
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _DISPLAY-FIELDS brCols wWin _FREEFORM
  QUERY brCols DISPLAY
      ttCol.cCol
      ttCol.cName 
      ttCol.cType 
      ttCol.iWidth
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
    WITH NO-ROW-MARKERS MULTIPLE SIZE 56.4 BY 21.91
         TITLE "Columns of" EXPANDABLE.

DEFINE BROWSE brTables
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _DISPLAY-FIELDS brTables wWin _FREEFORM
  QUERY brTables DISPLAY
      ttTable.cLabel
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
    WITH NO-ROW-MARKERS SIZE 39 BY 27.14
         TITLE "Tables" EXPANDABLE.

DEFINE BROWSE brValues
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _DISPLAY-FIELDS brValues wWin _FREEFORM
  QUERY brValues DISPLAY
      ttValue.iRow
      ttValue.cValue
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
    WITH NO-ROW-MARKERS SIZE 53.4 BY 16.19
         TITLE "Values of" EXPANDABLE.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME fMain
     fiColNameHeader AT ROW 1.48 COL 57.8 COLON-ALIGNED
     fiFile AT ROW 1.48 COL 92.2 COLON-ALIGNED
     btnViewFile AT ROW 1.48 COL 141.4
     brTables AT ROW 1.71 COL 2.8
     fiFormat AT ROW 2.43 COL 57.8 COLON-ALIGNED
     fiMaxScanRows AT ROW 2.43 COL 92.2 COLON-ALIGNED
     btnEmail AT ROW 2.91 COL 141.4
     fiDelimiter AT ROW 3.38 COL 57.8 COLON-ALIGNED
     fiCharacterSet AT ROW 3.38 COL 92.2 COLON-ALIGNED
     btnXR AT ROW 4.33 COL 141.4
     fiReport AT ROW 4.57 COL 57.8 COLON-ALIGNED
     fiSearchValue AT ROW 5.76 COL 41.6 COLON-ALIGNED NO-LABEL
     brCols AT ROW 6.95 COL 43.6
     brValues AT ROW 6.95 COL 101.8
     edValue AT ROW 24.1 COL 101.8 NO-LABEL
     rctMatrix AT ROW 29.33 COL 2.8
     "Choose columns (with CTRL + CLICK MOUSE) and press Enter" VIEW-AS TEXT
          SIZE 112.2 BY 2.86 AT ROW 32.19 COL 34.6
          FGCOLOR 7 FONT 31
     "Edit value (save on leave):" VIEW-AS TEXT
          SIZE 45 BY .62 AT ROW 23.38 COL 102.2
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 156.4 BY 37.38.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: SmartWindow
   Allow: Basic,Browse,DB-Fields,Query,Smart,Window
   Container Links: Data-Target,Data-Source,Page-Target
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
IF SESSION:DISPLAY-TYPE = "GUI":U THEN
  CREATE WINDOW wWin ASSIGN
         HIDDEN             = YES
         TITLE              = "Printdata Explorer"
         HEIGHT             = 37.38
         WIDTH              = 156.4
         MAX-HEIGHT         = 77.05
         MAX-WIDTH          = 210
         VIRTUAL-HEIGHT     = 77.05
         VIRTUAL-WIDTH      = 210
         RESIZE             = no
         SCROLL-BARS        = no
         STATUS-AREA        = no
         BGCOLOR            = ?
         FGCOLOR            = ?
         THREE-D            = yes
         MESSAGE-AREA       = no
         SENSITIVE          = yes.
ELSE {&WINDOW-NAME} = CURRENT-WINDOW.

ASSIGN {&WINDOW-NAME}:MENUBAR    = MENU MENU-BAR-wWin:HANDLE.
/* END WINDOW DEFINITION                                                */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB wWin 
/* ************************* Included-Libraries *********************** */

{system/super/sp-containr.i}
{system/super/sp-file.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME




/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW wWin
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME fMain
                                                                        */
/* BROWSE-TAB brTables btnViewFile fMain */
/* BROWSE-TAB brCols fiSearchValue fMain */
/* BROWSE-TAB brValues brCols fMain */
ASSIGN 
       brCols:COLUMN-RESIZABLE IN FRAME fMain       = TRUE
       brCols:COLUMN-MOVABLE IN FRAME fMain         = TRUE.

ASSIGN 
       brTables:COLUMN-RESIZABLE IN FRAME fMain       = TRUE.

ASSIGN 
       brValues:COLUMN-RESIZABLE IN FRAME fMain       = TRUE
       brValues:COLUMN-MOVABLE IN FRAME fMain         = TRUE.

/* SETTINGS FOR BUTTON btnEmail IN FRAME fMain
   NO-ENABLE                                                            */
/* SETTINGS FOR BUTTON btnXR IN FRAME fMain
   NO-ENABLE                                                            */
ASSIGN 
       fiCharacterSet:READ-ONLY IN FRAME fMain        = TRUE.

ASSIGN 
       fiColNameHeader:READ-ONLY IN FRAME fMain        = TRUE.

ASSIGN 
       fiDelimiter:READ-ONLY IN FRAME fMain        = TRUE.

ASSIGN 
       fiFile:READ-ONLY IN FRAME fMain        = TRUE.

ASSIGN 
       fiFormat:READ-ONLY IN FRAME fMain        = TRUE.

ASSIGN 
       fiMaxScanRows:READ-ONLY IN FRAME fMain        = TRUE.

/* SETTINGS FOR FILL-IN fiReport IN FRAME fMain
   NO-ENABLE                                                            */
IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(wWin)
THEN wWin:HIDDEN = yes.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME


/* Setting information for Queries and Browse Widgets fields            */

&ANALYZE-SUSPEND _QUERY-BLOCK BROWSE brCols
/* Query rebuild information for BROWSE brCols
     _START_FREEFORM
OPEN QUERY {&SELF-NAME}
   FOR EACH ttCol WHERE
            ttCol.table-UID EQ ttTable.UID
            NO-LOCK.
     _END_FREEFORM
     _Query            is OPENED
*/  /* BROWSE brCols */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _QUERY-BLOCK BROWSE brTables
/* Query rebuild information for BROWSE brTables
     _START_FREEFORM
OPEN QUERY {&SELF-NAME}
   FOR EACH ttTable NO-LOCK.
     _END_FREEFORM
     _Query            is OPENED
*/  /* BROWSE brTables */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _QUERY-BLOCK BROWSE brValues
/* Query rebuild information for BROWSE brValues
     _START_FREEFORM
OPEN QUERY {&SELF-NAME}
   FOR EACH ttValue WHERE
            ttValue.colUID EQ ttCol.UID
        AND ttValue.iRow    GE 2
            NO-LOCK.
     _END_FREEFORM
     _Query            is OPENED
*/  /* BROWSE brValues */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME wWin
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL wWin wWin
ON END-ERROR OF wWin /* Printdata Explorer */
OR ENDKEY OF {&WINDOW-NAME} ANYWHERE DO:
  /* This case occurs when the user presses the "Esc" key.
     In a persistently run window, just ignore this.  If we did not, the
     application would exit. */
  IF THIS-PROCEDURE:PERSISTENT THEN RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL wWin wWin
ON WINDOW-CLOSE OF wWin /* Printdata Explorer */
DO:
   RUN exitObject.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define BROWSE-NAME brCols
&Scoped-define SELF-NAME brCols
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL brCols wWin
ON RETURN OF brCols IN FRAME fMain /* Columns of */
DO:
   RUN createMatrix.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL brCols wWin
ON ROW-DISPLAY OF brCols IN FRAME fMain /* Columns of */
DO:
   IF NOT ttCol.lMatchSearch 
   THEN RETURN.
   
   ttCol.cCol  :FGCOLOR IN BROWSE brCols = 12.
   ttCol.cName :FGCOLOR IN BROWSE brCols = 12.
   ttCol.cType :FGCOLOR IN BROWSE brCols = 12.
   ttCol.iWidth:FGCOLOR IN BROWSE brCols = 12.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL brCols wWin
ON VALUE-CHANGED OF brCols IN FRAME fMain /* Columns of */
DO:
   {&OPEN-QUERY-brValues}
   BROWSE brValues:TITLE = 'Values of ' + ttTable.cLabel + '.' + ttCol.cName .
   APPLY 'VALUE-CHANGED' TO brValues.
   brValues:SENSITIVE = AVAILABLE ttValue.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define BROWSE-NAME brTables
&Scoped-define SELF-NAME brTables
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL brTables wWin
ON ROW-DISPLAY OF brTables IN FRAME fMain /* Tables */
DO:
   IF NOT ttTable.lMatchSearch 
   THEN RETURN.
   
   ttTable.cLabel:FGCOLOR IN BROWSE brTables = 12.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL brTables wWin
ON VALUE-CHANGED OF brTables IN FRAME fMain /* Tables */
DO:
   {&OPEN-QUERY-brCols}
   ASSIGN
      fiColNameHeader:SCREEN-VALUE = ttTable.cColNameHeader 
      fiFormat       :SCREEN-VALUE = ttTable.cFormat       
      fiDelimiter    :SCREEN-VALUE = ttTable.cDelimiter    
      fiMaxScanRows  :SCREEN-VALUE = STRING(ttTable.iMaxScanRows)  
      fiCharacterset :SCREEN-VALUE = ttTable.cCharacterset
      fiFile         :SCREEN-VALUE = ttTable.cFile
      BROWSE brCols:TITLE = 'Columns of ' + ttTable.cLabel .
   APPLY 'VALUE-CHANGED' TO brCols.   
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define BROWSE-NAME brValues
&Scoped-define SELF-NAME brValues
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL brValues wWin
ON ROW-DISPLAY OF brValues IN FRAME fMain /* Values of */
DO:
   IF NOT ttValue.lMatchSearch 
   THEN RETURN.
   
   ttValue.iRow  :FGCOLOR IN BROWSE brValues = 12.
   ttValue.cValue:FGCOLOR IN BROWSE brValues = 12.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL brValues wWin
ON VALUE-CHANGED OF brValues IN FRAME fMain /* Values of */
DO:
  IF AVAILABLE ttValue 
  THEN ASSIGN  
          edValue:SENSITIVE    = YES
          edValue:SCREEN-VALUE = ttValue.cValue.
  ELSE ASSIGN 
          edValue:SENSITIVE    = NO
          edValue:SCREEN-VALUE = ''.
  
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME btnViewFile
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL btnViewFile wWin
ON CHOOSE OF btnViewFile IN FRAME fMain /* View File */
DO:
  EXECUTE('notepad "' + fiFile:SCREEN-VALUE + '"','windowStyle=4',NO /*wait*/). /*windowStyle 4 Displays a window in its most recent size and position. The active window remains active.*/ 
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME edValue
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL edValue wWin
ON LEAVE OF edValue IN FRAME fMain
DO:
  IF SELF:SCREEN-VALUE EQ ttValue.cValue 
  THEN RETURN.
  
  MESSAGE 'Write these changes to' ttTable.cFile '?'
     VIEW-AS ALERT-BOX QUESTION BUTTONS YES-NO UPDATE lWrite AS LOG.
  
  IF NOT lWrite 
  THEN RETURN.
  
  MESSAGE 'nog inbouwen, nu nog niet mogelijk'.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME fiSearchValue
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL fiSearchValue wWin
ON ENTRY OF fiSearchValue IN FRAME fMain
DO:
   IF SELF:FGCOLOR NE ? 
   THEN SELF:SCREEN-VALUE = ''.
   SELF:FGCOLOR = ?.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL fiSearchValue wWin
ON F12 OF fiSearchValue IN FRAME fMain
DO:
  APPLY 'U1' TO SELF.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL fiSearchValue wWin
ON LEAVE OF fiSearchValue IN FRAME fMain
DO:
   APPLY 'U1' TO SELF.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL fiSearchValue wWin
ON RETURN OF fiSearchValue IN FRAME fMain
DO:
  APPLY 'U1' TO SELF.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL fiSearchValue wWin
ON U1 OF fiSearchValue IN FRAME fMain
DO:
  /*-- resetten --*/
  FOR EACH ttValue WHERE
           ttValue.lMatchSearch
           EXCLUSIVE-LOCK:
     ttValue.lMatchSearch = NO.      
  END.
  FOR EACH ttCol WHERE
           ttCol.lMatchSearch
           EXCLUSIVE-LOCK:
     ttCol.lMatchSearch = NO.
  END.
  FOR EACH ttTable WHERE
           ttTable.lMatchSearch
           EXCLUSIVE-LOCK:
     ttTable.lMatchSearch = NO.      
  END.
  
  /*-- markeren --*/
  FOR EACH ttValue WHERE  
           ttValue.cValue           MATCHES SELF:SCREEN-VALUE
        OR TRIM(ttValue.cValue,'"') MATCHES SELF:SCREEN-VALUE /*tegen verwaring met char's*/
           EXCLUSIVE-LOCK:
     ttValue.lMatchSearch = YES.
     FIND ttCol WHERE
          ttCol.UID EQ ttValue.colUID
          EXCLUSIVE-LOCK.
     ttCol.lMatchSearch = YES.
     FIND ttTable WHERE
          ttTable.UID EQ ttCol.table-UID
          EXCLUSIVE-LOCK.
     ttTable.lMatchSearch = YES.          
  END.
  
  /*-- browsers bijwerken --*/
  {&OPEN-QUERY-brTables}
  {&OPEN-QUERY-brCols}
  {&OPEN-QUERY-brValues}
  
  /*-- regels weer selecteren waar we op stonden --*/
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME mRefresh
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL mRefresh wWin
ON CHOOSE OF MENU-ITEM mRefresh /* Refresh */
DO:
  RUN LoadSchema.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define BROWSE-NAME brCols
&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK wWin 


/* ***************************  Main Block  *************************** */

/* Include custom  Main Block code for SmartWindows. */
/*{adm2/windowmn.i}*/
    MAIN-BLOCK:
    DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
       ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:
 
    /* Now enable the interface and wait for the exit condition.            */
       RUN initializeObject.
       IF NOT THIS-PROCEDURE:PERSISTENT THEN
           WAIT-FOR CLOSE OF THIS-PROCEDURE.
    END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE adm-create-objects wWin  _ADM-CREATE-OBJECTS
PROCEDURE adm-create-objects :
/*------------------------------------------------------------------------------
  Purpose:     Create handles for all SmartObjects used in this procedure.
               After SmartObjects are initialized, then SmartLinks are added.
  Parameters:  <none>
------------------------------------------------------------------------------*/

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE CreateMatrix wWin 
PROCEDURE CreateMatrix :
/*------------------------------------------------------------------------------
  Notes:       
------------------------------------------------------------------------------*/
   DEF VAR iFld      AS INT    NO-UNDO.
   DEF VAR hFld      AS HANDLE NO-UNDO.
   DEF VAR iRow      AS INT    NO-UNDO.
   DEF VAR iNumRows  AS INT    NO-UNDO.
   DEF VAR hBuf      AS HANDLE NO-UNDO.
   DEF VAR iNumFlds  AS INT    NO-UNDO.
   DEF VAR iFldWidth AS INT    NO-UNDO EXTENT 99.
   DEF VAR cFldName  AS CHAR   NO-UNDO EXTENT 99.
   DEF VAR iFldUID   AS INT    NO-UNDO EXTENT 99.
   DEF BUFFER bValue FOR ttValue.

&MESSAGE "uitzoeken waarom 2e openen matrix progress crashed"
   /*-- vorige matrix opruimen --*/
   ghQryMatrix:QUERY-CLOSE().
   IF ghTmpMatrix:PREPARED 
   THEN DO:
      hBuf = ghTmpMatrix:DEFAULT-BUFFER-HANDLE.
      hBuf:BUFFER-RELEASE().
   END.
   ghTmpMatrix:CLEAR(). 
   IF VALID-HANDLE(ghBrwMatrix) 
   THEN DELETE OBJECT ghBrwMatrix.
   
   IF brCols:NUM-SELECTED-ROWS IN FRAME {&FRAME-NAME} LT 1 
   THEN RETURN.
   
   /*-- matrix samenstellen --*/
   rows:
   DO iRow = 1 TO brCols:NUM-SELECTED-ROWS:
      brCols:FETCH-SELECTED-ROW(iRow).
      ghTmpMatrix:ADD-NEW-FIELD(ttCol.cName,'CHAR',0,'X(255)').
      iNumFlds           = iNumFlds + 1.
      cFldName [iNumFlds] = ttCol.cName. 
      iFldUID  [iNumFlds] = ttCol.UID.
      iFldWidth[iNumFlds] = LENGTH(ttCol.cName).
      IF iNumFlds EQ 99 
      THEN LEAVE rows.
   END.
   
   /*-- nieuwe matrix activeren --*/
   ghTmpMatrix:TEMP-TABLE-PREPARE('matrix').
   hBuf = ghTmpMatrix:DEFAULT-BUFFER-HANDLE.
   
   /*-- vullen nieuwe matrix --*/
   FIND LAST bValue NO-LOCK WHERE
             bValue.colUid EQ ttCol.UID.
   iNumRows = bValue.iRow.
   DO iRow = 2 TO iNumRows: /*1e row = veldnamen*/
      hBuf:BUFFER-CREATE.
      DO iFld = 1 TO iNumFlds:
         FIND bValue        NO-LOCK WHERE
              bValue.colUID EQ iFldUID[iFld]
          AND bValue.iRow   EQ iRow.
         hFld              = hBuf:BUFFER-FIELD(cFldName[iFld]).
         hFld:BUFFER-VALUE = bValue.cValue.
         /*-- max breedte bepalen voor columns --*/
         iFldWidth[iFld]   = MAXIMUM(iFldWidth[iFld],LENGTH(bValue.cValue)).
      END. /*do iFld*/
   END. /*do iRow*/
   
   /*-- en query openen voor brMatrix --*/
   ghQryMatrix:SET-BUFFERS(hBuf).
   ghQryMatrix:QUERY-PREPARE('FOR EACH matrix').
   ghQryMatrix:QUERY-OPEN().
   
   /*-- en browser aanmaken --*/
   CREATE BROWSE ghBrwMatrix
      ASSIGN 
         TITLE                = 'Table ' + ttTable.cLabel  
         FRAME                = FRAME {&FRAME-NAME}:HANDLE
         QUERY                = ghQryMatrix
         X                    = rctMatrix:X
         Y                    = rctMatrix:Y
         WIDTH-PIXELS         = rctMatrix:WIDTH-PIXELS
         HEIGHT-PIXELS        = rctMatrix:HEIGHT-PIXELS
         ROW-HEIGHT-PIXELS    = BROWSE brValues:ROW-HEIGHT-PIXELS
         ROW-MARKERS          = BROWSE brValues:ROW-MARKERS
         SEPARATORS           = BROWSE brValues:SEPARATORS
         SENSITIVE            = YES
         VISIBLE              = YES
         READ-ONLY            = NO .
   ghBrwMatrix:ADD-COLUMNS-FROM(hBuf).
   /*-- breedte column instellen op grootst gevonden waarde --*/
   DO iFld = 1 TO ghBrwMatrix:NUM-COLUMNS:
      hFld = ghBrwMatrix:GET-BROWSE-COLUMN(iFld).
      hFld:WIDTH-CHARS = MINIMUM(iFldWidth[iFld],50) + 2.
   END.
   ghBrwMatrix:REFRESH().
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI wWin  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Delete the WINDOW we created */
  IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(wWin)
  THEN DELETE WIDGET wWin.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI wWin  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY fiColNameHeader fiFile fiFormat fiMaxScanRows fiDelimiter 
          fiCharacterSet fiReport fiSearchValue edValue 
      WITH FRAME fMain IN WINDOW wWin.
  ENABLE fiColNameHeader fiFile btnViewFile brTables fiFormat fiMaxScanRows 
         fiDelimiter fiCharacterSet fiSearchValue brCols brValues edValue 
         rctMatrix 
      WITH FRAME fMain IN WINDOW wWin.
  {&OPEN-BROWSERS-IN-QUERY-fMain}
  VIEW wWin.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE ExitObject wWin 
PROCEDURE ExitObject :
/*------------------------------------------------------------------------------
  Purpose:  Window-specific override of this procedure which destroys 
            its contents and itself.
    Notes:  
------------------------------------------------------------------------------*/
   DEF VAR hBuf AS HANDLE NO-UNDO.
   
   ghQryMatrix:QUERY-CLOSE().
   IF ghTmpMatrix:PREPARED 
   THEN DO:
      hBuf = ghTmpMatrix:DEFAULT-BUFFER-HANDLE.
      hBuf:BUFFER-RELEASE().
   END.
   
   DELETE OBJECT ghTmpMatrix.
   DELETE OBJECT ghQryMatrix.
   IF VALID-HANDLE(ghBrwMatrix) 
   THEN DELETE OBJECT ghBrwMatrix.
   
   APPLY "CLOSE" TO THIS-PROCEDURE.
   
   RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE InitializeObject wWin 
PROCEDURE InitializeObject :
/*------------------------------------------------------------------------------
  Notes:       
------------------------------------------------------------------------------*/

   /* Code placed here will execute PRIOR to standard behavior. */
   {system/include/sp-window-init.i}
   

RUN SUPER.
 
   
   /* Code placed here will execute AFTER standard behavior.    */
   RUN LoadSchema.
   
   CREATE QUERY      ghQryMatrix.
   CREATE TEMP-TABLE ghTmpMatrix.
   
   
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE LoadSchema wWin 
PROCEDURE LoadSchema :
/*------------------------------------------------------------------------------
  Notes:       
------------------------------------------------------------------------------*/
   DEF VAR cTmpDir AS CHAR   NO-UNDO.
   DEF VAR cLine   AS CHAR   NO-UNDO.
   DEF VAR cLine2  AS CHAR   NO-UNDO.
   DEF VAR iLength AS INT    NO-UNDO.
   DEF VAR cTmp    AS CHAR   NO-UNDO.
   DEF VAR iSeq    AS INT    NO-UNDO EXTENT 3.
   DEF VAR iLine   AS INT    NO-UNDO.

   EMPTY TEMP-TABLE ttTable.
   EMPTY TEMP-TABLE ttCol.
   EMPTY TEMP-TABLE ttValue.
   
   {system/include/sp-tempdir.i &vulvar = cTmpdir }
                                           
   INPUT FROM VALUE(cTmpDir + '\schema.ini').
      REPEAT:
         IMPORT UNFORMATTED cLine NO-ERROR.
         cLine   = TRIM(cLine).
         CASE TRUE:
            WHEN cLine BEGINS '['THEN DO:
               CREATE 
                  ttTable.
               ASSIGN
                  iLength                = LENGTH(cLine)
                  iSeq[1]                = iSeq[1] + 1
                  ttTable.UID            = iSeq[1] 
                  ttTable.cColNameHeader = SUBSTRING(cLine,2,iLength - 2)
                  ttTable.cLabel         = SUBSTRING(cLine,2,iLength - 6)
                  ttTable.cFile          = cTmpDir + '\' + ttTable.cColNameHeader .
            END.
            WHEN cLine BEGINS 'ColNameHeader' THEN /*niks*/.
            WHEN cLine BEGINS 'format'        THEN ASSIGN
                                                   ttTable.cFormat       = ENTRY(2,cLine,'=') /*format=delimeted(;)*/
                                                   ttTable.cDelimiter    = TRIM(ENTRY(2,ttTable.cFormat,'(')
                                                                               ,')') .
            WHEN cLine BEGINS 'MaxScanRows'   THEN ttTable.iMaxScanRows  = INTEGER(ENTRY(2,cLine,'=')).
            WHEN cLine BEGINS 'CharacterSet'  THEN ttTable.cCharacterset = ENTRY(2,cLine,'=').
            WHEN cLine BEGINS 'Col'           THEN DO:
                 CREATE 
                    ttCol.
                 ASSIGN 
                    iSeq[2]             = iSeq[2] + 1
                    ttCol.UID           = iSeq[2]
                    ttCol.table-UID     = ttTable.UID
                    cTmp                = ENTRY(1,cLine,' ')
                    ttCol.cCol          = ENTRY(1,cTmp,'=')
                    ttCol.cName         = ENTRY(2,cTmp,'=')
                    ttCol.cType         = ENTRY(2,cLine,' ')
                    ttCol.iWidth        = INTEGER(ENTRY(4,cLine,' ')) WHEN NUM-ENTRIES(cLine,' ') GE 4  /*3= 'width' */ 
                    ttCol.iEntry        = INTEGER(SUBSTRING(ttCol.cCol,4))
                    ttTable.iNumEntries = MAX(ttTable.iNumEntries,ttCol.iEntry) .
            END.
         END CASE.
      END. /*repeat*/
   INPUT CLOSE.
   
   tbl:
   FOR EACH ttTable NO-LOCK:
      INPUT FROM VALUE(ttTable.cFile).
         iLine = 0.
         REPEAT:
            iLine = iLine + 1.
            IMPORT UNFORMATTED cLine.
            cLine = TRIM(cLine).
            /*-- chr 10/13 afvangen in velden zoals bv NAW --*/
            DO WHILE NUM-ENTRIES(cLine,ttTable.cDelimiter) LT ttTable.iNumEntries:
               IMPORT UNFORMATTED cLine2.
               cLine = cLine + CHR(10) + TRIM(cLine2). 
            END.

            ttCol:
            FOR EACH ttCol WHERE
                     ttCol.table-UID EQ ttTable.UID
                     NO-LOCK:
               CREATE
                  ttValue.
               ASSIGN
                  iSeq[3]         = iSeq[3] + 1
                  ttValue.UID     = iSeq[3]
                  ttValue.colUID = ttCol.UID
                  ttValue.iRow    = iLine
                  ttValue.cValue  = ENTRY(ttCol.iEntry,cLine,ttTable.cDelimiter) .
            END. /*each ttCol*/
         END. /*repeat*/
      INPUT CLOSE.
   END. /*each table*/

   {&OPEN-QUERY-brTables}
   APPLY 'VALUE-CHANGED' TO brTables IN FRAME {&FRAME-NAME}.
   
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

