DEFINE STREAM bestand.

DEF VAR cImportFile          AS CHARACTER NO-UNDO. 
DEF VAR cImportLine          AS CHARACTER NO-UNDO.
DEF VAR cHeaderLine          AS CHARACTER NO-UNDO.
DEF VAR lFirstLine           AS LOGICAL   NO-UNDO INITIAL YES.
DEF VAR i                    AS INTEGER   NO-UNDO.

DEF VAR iCSLCustID           AS INTEGER   NO-UNDO.

DEF VAR iVIACustID           AS INTEGER   NO-UNDO.

DEF VAR lOk                  AS LOGICAL   NO-UNDO.
DEF VAR lHasWarnings         AS LOGICAL   NO-UNDO.
DEF VAR iRead                AS INTEGER   NO-UNDO.
DEF VAR iSenderDone          AS INTEGER   NO-UNDO.
DEF VAR iReceiverDone        AS INTEGER   NO-UNDO.
DEF VAR iFailed              AS INTEGER   NO-UNDO.
DEF VAR cLogfile             AS CHARACTER NO-UNDO.

cImPortFile = "C:\Users\Ries\Desktop\ViaSea\CSL-VIA-address.txt".

INPUT STREAM bestand FROM VALUE(cImportFile).

bestand_lezen:
REPEAT:

  IMPORT STREAM bestand UNFORMATTED cImportLine.

  IF TRIM(cImportLine) = "" THEN NEXT bestand_lezen.
  
  IF lFirstLine = YES
  THEN DO:
    cHeaderLine = cImportLine.

    IF NUM-ENTRIES(cHeaderline,CHR(9)) < 2
    THEN DO:
      MESSAGE "Import file" cImportFile "should have at least 2 columns, tab separated" VIEW-AS ALERT-BOX ERROR.
      LEAVE bestand_lezen.
    END.

    lFirstLine = NO.
    NEXT bestand_lezen.

  END. /* lFirstline */

  /* --- */

  IF TRIM(cImportLine) = "" THEN NEXT bestand_lezen.

  ASSIGN
     iCSLCustId = INTEGER(ENTRY(1, cImportLine, CHR(9)))
     iVIACustID = INTEGER(ENTRY(2, cImportLine, CHR(9))).
     
  iRead = iRead + 1.

  FIND ca-edi_sender_codes WHERE 
       ca-edi_sender_codes.companycode = "EUC"
   AND ca-edi_sender_codes.sendercode  = "CSL-BF" 
   AND ca-edi_sender_codes.tablecode   = "aa-address"
   AND ca-edi_sender_codes.edi_code    = STRING(iCSLCustID) EXCLUSIVE-LOCK NO-ERROR.
  
  IF NOT AVAILABLE ca-edi_sender_codes
  THEN DO:
    CREATE ca-edi_sender_codes.
    ASSIGN ca-edi_sender_codes.companycode = "EUC"
           ca-edi_sender_codes.sendercode  = "CSL-BF" 
           ca-edi_sender_codes.tablecode   = "aa-address"
           ca-edi_sender_codes.edi_code    = STRING(iCSLCustID)
           ca-edi_sender_codes.code        = STRING(iVIACustID)
           iSenderDone = iSenderDone + 1.
  END.  
  
  FIND ca-edi_receiver_codes WHERE 
       ca-edi_receiver_codes.companycode  = "EUC"
   AND ca-edi_receiver_codes.receivercode = "CSL-BF" 
   AND ca-edi_receiver_codes.tablecode    = "aa-address"
   AND ca-edi_receiver_codes.code         = STRING(iVIACustID) EXCLUSIVE-LOCK NO-ERROR.
  
  IF NOT AVAILABLE ca-edi_receiver_codes
  THEN DO:
    CREATE ca-edi_receiver_codes.
    ASSIGN ca-edi_receiver_codes.companycode  = "EUC"
           ca-edi_receiver_codes.receivercode = "CSL-BF" 
           ca-edi_receiver_codes.tablecode    = "aa-address"
           ca-edi_receiver_codes.code         = STRING(iVIACustID)
           ca-edi_receiver_codes.edi_code     = STRING(iCSLCustID)
           iReceiverDone = iReceiverDone + 1.
  END.  
  NEXT bestand_lezen.
  
END. /* repeat */

INPUT STREAM bestand CLOSE.

MESSAGE iSenderDone   "EDI Sender codes updated .." SKIP
        iReceiverDone "EDI Sender codes updated .."
        VIEW-AS ALERT-BOX.

 
